#ifndef YYERRCODE
#define YYERRCODE 256
#endif

#define L_EOS 257
#define L_IPADDR 258
#define L_NUMBER 259
#define L_STRING 260
#define L_QSTRING 261
#define L_END_INCLUDE 262
#define T_INCLUDE 263
#define T_OPTIONS 264
#define T_DIRECTORY 265
#define T_PIDFILE 266
#define T_NAMED_XFER 267
#define T_DUMP_FILE 268
#define T_STATS_FILE 269
#define T_MEMSTATS_FILE 270
#define T_FAKE_IQUERY 271
#define T_RECURSION 272
#define T_FETCH_GLUE 273
#define T_HITCOUNT 274
#define T_PREFERRED_GLUE 275
#define T_QUERY_SOURCE 276
#define T_QUERY_SOURCE_V6 277
#define T_LISTEN_ON 278
#define T_LISTEN_ON_V6 279
#define T_PORT 280
#define T_ADDRESS 281
#define T_RRSET_ORDER 282
#define T_ORDER 283
#define T_NAME 284
#define T_CLASS 285
#define T_CONTROLS 286
#define T_INET 287
#define T_UNIX 288
#define T_PERM 289
#define T_OWNER 290
#define T_GROUP 291
#define T_ALLOW 292
#define T_DATASIZE 293
#define T_STACKSIZE 294
#define T_CORESIZE 295
#define T_DEFAULT 296
#define T_UNLIMITED 297
#define T_FILES 298
#define T_VERSION 299
#define T_HOSTNAME 300
#define T_HOSTSTATS 301
#define T_HOSTSTATSMAX 302
#define T_DEALLOC_ON_EXIT 303
#define T_TRANSFERS_IN 304
#define T_TRANSFERS_OUT 305
#define T_TRANSFERS_PER_NS 306
#define T_TRANSFER_FORMAT 307
#define T_MAX_TRANSFER_TIME_IN 308
#define T_SERIAL_QUERIES 309
#define T_ONE_ANSWER 310
#define T_MANY_ANSWERS 311
#define T_NOTIFY 312
#define T_EXPLICIT 313
#define T_NOTIFY_INITIAL 314
#define T_AUTH_NXDOMAIN 315
#define T_MULTIPLE_CNAMES 316
#define T_USE_IXFR 317
#define T_MAINTAIN_IXFR_BASE 318
#define T_CLEAN_INTERVAL 319
#define T_INTERFACE_INTERVAL 320
#define T_STATS_INTERVAL 321
#define T_MAX_LOG_SIZE_IXFR 322
#define T_HEARTBEAT 323
#define T_USE_ID_POOL 324
#define T_MAX_NCACHE_TTL 325
#define T_HAS_OLD_CLIENTS 326
#define T_RFC2308_TYPE1 327
#define T_LAME_TTL 328
#define T_MIN_ROOTS 329
#define T_TREAT_CR_AS_SPACE 330
#define T_EDNS_UDP_SIZE 331
#define T_LOGGING 332
#define T_CATEGORY 333
#define T_CHANNEL 334
#define T_SEVERITY 335
#define T_DYNAMIC 336
#define T_FILE 337
#define T_VERSIONS 338
#define T_SIZE 339
#define T_SYSLOG 340
#define T_DEBUG 341
#define T_NULL_OUTPUT 342
#define T_PRINT_TIME 343
#define T_PRINT_CATEGORY 344
#define T_PRINT_SEVERITY 345
#define T_SORTLIST 346
#define T_TOPOLOGY 347
#define T_SERVER 348
#define T_LONG_AXFR 349
#define T_BOGUS 350
#define T_TRANSFERS 351
#define T_KEYS 352
#define T_SUPPORT_IXFR 353
#define T_EDNS 354
#define T_ZONE 355
#define T_IN 356
#define T_CHAOS 357
#define T_HESIOD 358
#define T_TYPE 359
#define T_MASTER 360
#define T_SLAVE 361
#define T_STUB 362
#define T_RESPONSE 363
#define T_HINT 364
#define T_MASTERS 365
#define T_TRANSFER_SOURCE 366
#define T_TRANSFER_SOURCE_V6 367
#define T_PUBKEY 368
#define T_ALSO_NOTIFY 369
#define T_DIALUP 370
#define T_FILE_IXFR 371
#define T_IXFR_TMP 372
#define T_TRUSTED_KEYS 373
#define T_ACL 374
#define T_ALLOW_UPDATE 375
#define T_ALLOW_QUERY 376
#define T_ALLOW_TRANSFER 377
#define T_ALLOW_RECURSION 378
#define T_BLACKHOLE 379
#define T_SEC_KEY 380
#define T_ALGID 381
#define T_SECRET 382
#define T_CHECK_NAMES 383
#define T_WARN 384
#define T_FAIL 385
#define T_IGNORE 386
#define T_FORWARD 387
#define T_FORWARDERS 388
#define T_ONLY 389
#define T_FIRST 390
#define T_IF_NO_ANSWER 391
#define T_IF_NO_DOMAIN 392
#define T_YES 393
#define T_TRUE 394
#define T_NO 395
#define T_FALSE 396
typedef union {
	char *			cp;
	int			s_int;
	long			num;
	u_long			ul_int;
	u_int16_t		us_int;
	union ns_sockaddr	ip_addr;
	ip_match_element	ime;
	ip_match_list		iml;
	rrset_order_list	rol;
	rrset_order_element	roe;
	struct dst_key *	keyi;
	enum axfr_format	axfr_fmt;
} YYSTYPE;
extern YYSTYPE yylval;
